Subject: Re: [bitcoindev] Pre-emptive commit/reveal for quantum-safe migration (poison-pill)

From: Leo Wandersleb <[email-masked]>
Date: Wed, 4 Jun 2025 10:39:38 -0700 (PDT)

Hi Boris,

the announcements, weak and strong would have to not be transactions yet to 
be compatible with legacy nodes and thus keep it a soft-fork. They could be 
OP_RETURN data. Only after the 144 blocks, the upgraded full nodes would 
allow the inclusion of the actual transaction. This would mean the 
transaction would be both in full in the OP_RETURN strong announcement and 
without the witness part later, so it would be a bit expensive this way but 
maybe we can do better?

A node that gets updated would have to re-index all the blockchain to find 
announcements if we don't introduce a time frame for actually using the 
announcements. We could also say that any announcement has to be used 
within another 1000 blocks. Then the upgrading node would have to re-index 
the last 1000 blocks.

The legitimate owner of a UTXO might wait for an attack for privacy 
reasons. My proposal would allow Satoshi himself to make all his UTXOs 
quantum safe without any of us learning about him being active. He could 
add one 64B OP_RETURN in 2027 and when QC becomes an issue, we would learn 
about him having been active in 2027 in 2040 when actually somebody tried 
to attack and not in 2027 when people started to panic because of imminent 
quantum breakthroughs.
Hmm ... a problem is the weak announcement doesn't require keys, so anybody 
could provoke Satoshi to come forward. Maybe we have to add key ownership 
as a requirement for the "weak" announcement, too. So it should also 
contain a serialized transaction.

Best,

Leo

On Wednesday, 4 June 2025 at 04:15:59 UTC+2 Nagaev Boris wrote:

> Hi Leo,
>
> Thanks for the clarifications, much appreciated!
> I have a couple of questions:
>
> 1. How is a weak announcement stored in the blockchain and in the UTXO set?
> I assume it must be a transaction, correct? And it should somehow mark
> the UTXO as planned to be spent for 144 blocks?
> How would older (non-upgraded) nodes interpret a transaction
> containing a weak announcement? Would they just skip over it without
> any special processing?
> If so, is there a problem for nodes that upgrade after the fork: would
> they have to reprocess all blocks since the fork to find and index all
> missed weak announcements?
>
> 2. In the case of reclaiming a UTXO after a weak announcement by an
> attacker: why would the legitimate owner wait for a weak announcement
> at all?
> If the EC public key was already leaked, it seems they should publish
> a strong announcement themselves rather than wait. If the EC public
> key wasn't leaked, there's nothing to worry about even if someone
> publishes a weak announcement: they are most likely bluffing, since
> they wouldn't have the actual public key.
>
> Best,
> Boris
>
> On Tue, Jun 3, 2025 at 3:29 PM Leo Wandersleb <[email-masked]> wrote:
> >
> > Hi conduition,
> >
> > Thanks for your careful analysis - excellent catches.
> >
> > You're absolutely right about the txid vulnerability. The commitment 
> must be to the complete transaction including witness data (wTXID or 
> equivalent) to prevent an attacker from pre-committing to unsigned 
> transactions. This is essential - otherwise an attacker could indeed 
> enumerate the UTXO set and create commitments without knowing the private 
> keys.
> >
> > Regarding updates: You're correct that frequent updates would be needed 
> as wallets receive new UTXOs. However, I don't see this as a major issue - 
> users could batch their commitments periodically (say, monthly) rather than 
> after every transaction. The scheme is particularly important for existing 
> UTXOs that already have exposed pubkeys (old P2PK, reused addresses, etc.). 
> For new UTXOs, wallets should ideally migrate to quantum-safe addresses 
> once available. OpenTimestamps aggregation would indeed help with scaling 
> and provide plausible deniability about the number of UTXOs being protected.
> >
> > The time delay serves a different purpose than you might expect. It's 
> not about preventing commitment forgery after pubkey exposure, but rather 
> about allowing priority based on commitment age when multiple parties claim 
> the same UTXO:
> >
> > 1. Weak announcement starts the 144-block window
> > 2. During this window, anyone with a strong commitment can reveal it
> > 3. The oldest valid commitment wins
> >
> > This creates the "poison pill" effect: an attacker might crack a key and 
> try to spend a UTXO, but if the original owner has an older commitment, 
> they can reclaim it during the window. The uncertainty about which UTXOs 
> have poison pills makes attacking large "lost" UTXOs risky - hence less 
> disruptive to the network.
> >
> > The delay essentially allows a "commitment priority contest" where age 
> determines the winner, protecting users who prepared early while still 
> allowing these users to not move their funds.
> >
> > Best,
> >
> > Leo
> >
> > --
> > You received this message because you are subscribed to the Google 
> Groups "Bitcoin Development Mailing List" group.
> > To unsubscribe from this group and stop receiving emails from it, send 
> an email to [email-masked].
> > To view this discussion visit 
> https://groups.google.com/d/msgid/bitcoindev/5e393f57-ac87-40fd-93ef-e1006accdb55n%40googlegroups.com
> .
>
>
>
> -- 
> Best regards,
> Boris Nagaev
>

-- 
You received this message because you are subscribed to the Google Groups "Bitcoin Development Mailing List" group.
To unsubscribe from this group and stop receiving emails from it, send an email to [email-masked].
To view this discussion visit https://groups.google.com/d/msgid/bitcoindev/5d9f6ac9-a623-4636-8a91-ee7c057bc08an%40googlegroups.com.